﻿var spscUrl = 'http://www.sportscanner.de/';
var spscSecureUrl = 'https://www.sportscanner.de/';
//var spscUrl = 'http://localhost:44300/';
//var spscSecureUrl = 'http://localhost:44300/';
var uploadHandlerUrl = 'Upload/UploadHandler.ashx';
var currentVersion = '1.0.134';


var KEYRESULT = 'Result';
var KEYINDEX = 'Index';
var KEYDETAILS = 'Details';
var KEYEVENTDETAILS = 'eventDetails';
var KEYMESSAGE = 'Message';
var KEYSEARCHSETTINGS = 'searchSettings';
var KEYUSERSETTINGS = 'userSettings';
var KEYSPORTS = 'sports';
var KEYCOURSES = 'courses';
var KEYDAYCOURSES = 'dayCourses;'
var KEYCOURSEDETAILS = 'courseDetails';
var KEYLANGUAGE = 'language';
var KEYLANGUAGESPORT = 'languageSport';
var KEYLOCALE = 'locale';
var KEYMAILMESSAGE = 'mailmessage';
var KEYEVENTLIST = 'events';
var KEYMAILBOX = 'mailbox';
var KEYMYCOURSES = 'myCourses';
var KEYDEALLIST = 'deallist';
var KEYDEALDETAILS = 'dealdetails';
var KEYMYDATA = 'mydata';

var MAXLATESTITEMS = 40;
var PAGETRANSITION = 'FADE';
var HIGHLIGHTEDCLASS = 'highlighter';
var languageData = {};
var languageSportsData = {};

var viewType = {
    list: 0,
    map: 1,
    details: 2
};

var mailboxType = {
    inbox: 0,
    outbox: 1
};

var searchType = {
    search: 0,
    latest: 1,
    myEvents: 2,
    myProvidersAndEvents: 3,
    providerEvents: 4,
    sendMessage: 5,
    sendCourseMessage: 6,
    login: 7,
    register: 8,
    getMessage: 9,
    getCourseMessage: 10,
    courseDetails: 11,
    toggleLike: 12,
    details: 13,
    addOrRemoveUserEvent: 14,
    getCourses: 15,
    mailbox: 16,
    myCourses: 17,
    dealList: 18,
    dealDetails: 19
};

var userSettings = {
    userName: '',
    password: '',
    saveSearchSettings: true,
    locale: 'de-DE',
    loginKey: '',
    loginName: '',
    providerId: 0,
    providerName: '',
    appCode: '',
    appVersion: ''
};

var searchSettings = {
    distance: 20,
    distanceText: '20 km',
    longitude: '',
    latitude: '',
    placeName: '',
    searchText: '',
    selectedCategory: 0,
    selectedCategoryName: '',
    sportsText: '',
    sports: []
};

var externalType = {
    help: 'Help.html'
};

var pages = {
    sportscanner: 'm1-Sportscanner',
	detailSearch: 'm1-DetailSearch', 
    details: 'm1-Details',
    map: 'm1-Map',
    providereventList: 'm1-ResultlistProviderEvents',
    resultList: 'm1-Resultlist', 
    eventList: 'm1-Eventlist', 
    description: 'm1-Description',
    selectCategory: 'm1-SelectCategories',
    selectSports: 'm1-SelectSports',
    selectDistance: 'm1-SelectDistance',
    settings: 'm1-Settings',
    courses: 'm1-Courses',
    courseDetails: 'm1-CourseDetails',
    login: 'm1-Login',
    staticContent: 'm1-StaticContent',
    register: 'm1-Register',
    detailsEvent: 'm1-DetailsEvent',
    pictures: 'm1-Pictures',
    messages: 'm1-WriteMail',
    courseSearch: 'm1-CourseSearch',
    courseMessages: 'm1-WriteCourseMessage',
    mailbox: 'm1-Mailbox',
    myCourses: 'm1-MyCourses',
    mailContent: 'm1-MailContent',
    nodata: 'm1-MessageNoData',
    deallist: 'm1-DealList',
    dealDetails: 'm1-DetailsDeals'
};

// variables are filled by the language - json
var strings = {
    searchIn: '',
    distance: '',
    distanceUnit: '',
    sport: '',
    all: '',
    search: '',
    errorTextSearch: '',
    entriesFound: '',
    moreentriesFound: '',
    singleEntryFound: '',
    latestEntries: '',
    mailText1: '',
    mailText2: '',
    mailText3: '',
    mailText4: '',
    mailText5: '',
    mailText6: '',
    noEntries: '',
    myCourses: '',
    notMyCourses: '',
    notLoggedIn: '',
    loggedIn: '',
    share1: '',
    share2: '',
    share3: '',
    share4: '',
    messageTo: '',
    membersOnly: '',
    thumbsUp: '',
    thumbsDown: '',
    responseCount: '',
    alertNoCourses: '',
    alertMailboxEmpty: ''
};

var categoriesEmpty = [0,0,0,0,0,0,0,0,0,0];
var sportsCategories = [0,1,1,1,1,1,1,1,1,1];
var resultList = [];
var lastDetailsView = viewType.details;
var lastView = viewType.list;
var lastProviderName = '';
var lastDetailsView = viewType.details;
var lastPage = pages.sportscanner;
var lastProviderId = 0;
var lastCourseId = 0;
var glob_locale = 'de';
var marker = null;
var allSportVisible = true;
var localeStandard = 'de-DE';
var sportsLoaded = false;
var useWizard = true;
var providerEventMode = false;
var isEventSearch = false;
var onlyCourseProvider = false;
var DistanceDetailMode = false;

// handle the back button
function handleBackButton() {
 console.log("Back Button Pressed!");
}


String.prototype.format = function () {
    var formatted = this;
    for (var i = 0; i < arguments.length; i++) {
        var regexp = new RegExp('\\{' + i + '\\}', 'gi');
        formatted = formatted.replace(regexp, arguments[i]);
    }
    return formatted;
};

String.prototype.trim = function () {
    var str = this;
    return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
};


var myData = {

    myDataType: 1,
    page: pages.providereventList,

    loadList: function () {
        var data = { userkey: userSettings.loginKey, appKey: userSettings.appCode, locale: userSettings.locale };
        ajaxHandler.load(searchType.myProvidersAndEvents, data, function (json) {
            if (json.Success) {
                myData.saveData(json.Data);
                myData.loadSingleList(myData.myDataType);
            }
            else {
                util.loadNoData(json.ReturnStateMessage);
            }
        });
    },

    saveData: function (data) {
        var msg = strings.responseCount.format(data.ProviderCount, data.EventCount)
        $(":root").data(KEYMESSAGE, msg);
        $(":root").data(KEYEVENTLIST, data.Events);
        $(":root").data(KEYRESULT, data.Provider);
    },

    loadSingleList: function (myDataType) {
        myData.myDataType = myDataType;
        var id = '#' + myData.page + '-btn';
        var inactiveMyDataType = myDataType == 1 ? 0 : 1;
        $('#' + myData.page + '-btn' + myData.myDataType).addClass('activeButton');
        $('#' + myData.page + '-btn' + inactiveMyDataType).removeClass('activeButton');

        var key = myDataType == 1 ? KEYRESULT : KEYEVENTLIST;
        providerEventMode = myDataType == 0;
        var lstData = $(":root").data(key);
        myData.renderList(lstData);
    },

    renderList: function (data) {
        util.gotoScreen(myData.page);
        var container_id = myData.page + '-pnlResultList';
        util.renderList(container_id, data, function (item, clone) {
            $("div[id*=txtHeader]", clone).text(item.Name);
            $("div[id*=txtSports]", clone).text(item.SportList);
            $("div[id*=txtCity]", clone).text(item.City);
            if (item.SportsUnitType == 1)
                $("div[id*=txtDate]", clone).text(item.FormattedDate)
            else
                $("div[id*=txtDate]", clone).text('');
            var distance = item.Distance != '0' ? item.Distance : '';
            $("div[id*=txtDistance]", clone).text(distance !== '' ? distance + ' km' : '');
            $("img[id*=img]", clone).attr("src", 'images/marker_' + item.SportsUnitType + '.png');
            $("div[id*=txtHeader]", clone).css("overflow", "hidden");
            $("div[id*=txtSports]", clone).css("overflow", "hidden");
            $("div[id*=txtCity]", clone).css("overflow", "hidden");
        });
        util.fillSearchMessage(myData.page, $(":root").data(KEYMESSAGE))
    },
};

var deals = {

    dealType: 1,

    loadList: function () {
        var data = { page: 0, locale: userSettings.locale };
        ajaxHandler.load(searchType.dealList, data, function (json) {
            if (json.Success) {
                $(":root").data(KEYDEALLIST, json.Data);
                deals.loadSingleList(0);
            }
            else {
                util.loadNoData(json.ReturnStateMessage);
            }
        });

    },

    loadSingleList: function (dealType)
    {
        var id = '#' + pages.deallist + '-btn';
        var inactiveDealType = dealType == 0 ? 1 : 0;
        $('#' + pages.deallist + '-btn' + dealType).addClass('activeButton');
        $('#' + pages.deallist + '-btn' + inactiveDealType).removeClass('activeButton');
        deals.dealType = dealType;
        var lstData = $(":root").data(KEYDEALLIST);
        deals.renderList(lstData);
    },

    loadDetails: function (element) {
        var lstData = $(":root").data(KEYDEALLIST);
        var currenList = lstData[deals.dealType];
        var selItem = $(element).closest('li[data-listitem-index]');
        var index = $(selItem).attr("data-listitem-index")
        var dealId = currenList[index].Id;
        var data = { dealId: dealId, locale: userSettings.locale };
        ajaxHandler.load(searchType.dealDetails, data, function (json) {
            if (json.Success) {
                $(":root").data(KEYDEALDETAILS, json.Data);
                analytics.write("DealDetails", "Deal"); // Tom hier m�ssen die Details angezeigt werden
                deals.renderDetails(json.Data);
            }
            else {
                util.loadNoData(json.ReturnStateMessage);
            }
        });
    },


    renderList: function (allData) {
        util.gotoScreen(pages.deallist);
        var data = allData[deals.dealType];
        var container_id = pages.deallist + '-pnlResultList';
        util.renderList(container_id, data, function (item, clone) {
            $("div[id*=txtHeader]", clone).text(item.Nm);
            $("div[id*=txtProvider]", clone).text(item.Pv);
            $("div[id*=txtDate]", clone).text(item.Dt);
            $("img[id*=imgLogo]", clone).attr("src", item.Im);
            $("div[id*=txtDescriptionShort]", clone).text(item.Tx);
            $("div[id*=imgType]", clone).text(item.Tp);
        });
    },

    renderDetails: function (data) {
        var page = pages.dealDetails;
        util.gotoScreen(page);
        util.setItem(page, 'lblHeader', null, data.Nm);
        util.setItem(page, 'lblProviderName', null, data.Pv);
        if (data.Pr != 0) util.setItem(page, 'lblPrice', null, data.Pr) // Tom
            else util.setItem(page, 'lblPrice', null, '');
        if (data.Dc == '') util.toggleVisibility(page, 'lblCode', 'hidden')
            else util.toggleVisibility(page, 'lblCode', 'visible');
                  
        util.setItem(page, 'lblVoucher', null, data.Dc);
        var imageStyle = 'min-width: 100%;height: auto;';
        $('#' + page + '-pnlImage').attr('src', data.Im);
        util.setItem(page, 'lblDescription', null, data.De, true);  
        phoneui.preprocessDOM();
    },

    openDealUrl: function () {
        var data = $(":root").data(KEYDEALDETAILS);
        var url = data.Url;
        phoneui.showURL(url, '_blank');
    },

    saveDetails: function () {
    }
};

var analytics = {

    create: function () {
        ga('create', 'UA-19021326-8', { 'storage': 'none', 'clientId': util.getAppCode() });
    },

    write: function (pageName, pageTitle) {
        ga('send', 'pageview', { 'page': pageName, 'title': pageTitle });
    }

};

var keyHandler = {

    eventType: {
        startSearch: 1,
        login: 2,
        geolocation: 3,
        courseSearch: 4
    },

    init: function () {
        $('#' + pages.selectSports + '-textSportSearch').on('input', function () {
            sports.searchSports();
        });

        $('#' + pages.detailSearch + '-txtCustomText').on('keypress', function (e) {
            keyHandler.handleKey(e.keyCode, keyHandler.eventType.startSearch);
        });
        
        $('#' + pages.detailSearch + '-txtLocation').on('keypress', function (e) {
            keyHandler.handleKey(e.keyCode, keyHandler.eventType.startSearch);
        });

        $('#' + pages.login + '-txtPassword').on('keypress', function (e) {
            keyHandler.handleKey(e.keyCode, keyHandler.eventType.login);
        });

        $('#' + pages.sportscanner + '-txtLocation').on('keypress', function (e) {
            keyHandler.handleKey(e.keyCode, keyHandler.eventType.geolocation);
        });

        $('#' + pages.courseSearch + '-txtLocation').on('keypress', function (e) {
            keyHandler.handleKey(e.keyCode, keyHandler.eventType.courseSearch); 
        });

        $('#' + pages.courseSearch + '-txtCustomText').on('keypress', function (e) {
            keyHandler.handleKey(e.keyCode, keyHandler.eventType.courseSearch);
        });

       
    },

    handleKey: function (keyCode, evt) {
        if (keyCode == 13) {
            switch (evt) {
                case this.eventType.startSearch:
                   mobiOne.showResults();
                    
                    break;
                case this.eventType.login:
                    mobiOne.login();
                    util.redraw();
                    phoneui.preprocessDOM(); 
                    break;
                case this.eventType.courseSearch:
                    mobiOne.courseSearch();
                    util.redraw();
                    phoneui.preprocessDOM();
                    break;
                case this.eventType.geolocation:
                    util.gotoScreen(pages.selectSports);
                    util.redraw(); 
                    phoneui.preprocessDOM();
                    break;
            }
        }
    }
};


var pictures = {

    currentPictureIndex: 0,
    maxPictures: 0,
    currentPage: 1,
    images: [],
    key: '',
    animation: 'SLIDE_LEFT',

    init: function () {
        var data = util.getDetailsData();
        if (data.Images != null) {
            $.each(data.Images, function (index, item) {
                if (!item.IsLogo)
                    pictures.images.push(item);
            });
            this.maxPictures = this.images.length;
            this.key = data.Key;
        }
        this.loadPage(1, false);
    },

    slideLeft: function () {
        this.animation = 'SLIDE_LEFT';
        this.currentPictureIndex = this.currentPictureIndex > 0 ? this.currentPictureIndex - 1 : this.currentPictureIndex = this.maxPictures - 1;
        this.loadPage(this.currentPage == 1 ? 2 : 1, true);
    },

    slideRight: function () {
        this.animation = 'SLIDE_RIGHT';
        this.currentPictureIndex = this.currentPictureIndex < this.maxPictures - 1 ? this.currentPictureIndex + 1 : this.currentPictureIndex = 0;
        this.loadPage(this.currentPage == 1 ? 2 : 1, true);
    },

    loadPage: function (pageNumber, changePage) {
       
        var url = '';
        var img = $('#' + pages.pictures + '-img' + this.currentPage.toString());
        if (this.images != undefined ? this.images.length > 0 : false) {
            this.currentPage = pageNumber;
            url = spscUrl + uploadHandlerUrl + '?f=' + encodeURIComponent(this.images[this.currentPictureIndex].ImageUrl) + '&id=' + this.key + '&thumbnail=false';
            img = $('#' + pages.pictures + '-img' + this.currentPage.toString());

            if (changePage) {
                phoneui.gotoMultiPagePage(pages.pictures + '-Picturepages', 'SET_PAGE', pages.pictures + '-' + 'PicturePage' + this.currentPage.toString(), this.animation);
            }
        }
        img.attr('src', url);
    }

};
var userLogin = {

    load: function () {
        util.gotoScreen(pages.login);
    },
    
    register: function () {
        var data = {
            FirstName: $('#' + pages.register + '-txtFirstName').val(),
            LastName: $('#' + pages.register + '-txtLastName').val(),
            Email: $('#' + pages.register + '-txtEmail').val().trim(),
            Password: $('#' + pages.register + '-txtPassword').val().trim(),
            ConfirmPassword: $('#' + pages.register + '-txtPassword2').val().trim(),
            Key: util.getAppCode(),
            Locale: userSettings.locale,
            AcceptGeneralConditions: $('#' + pages.register + '-chkAgb input').is(':checked')
        };
        ajaxHandler.load(searchType.register, data, function (json) {
            var color = '#f11d1d';
            if (json.Success) {
                color = '#0b7c0e';
            }
            var divContainer = '<div style="color:' + color + ';font-size:12px;">' + json.ReturnStateMessage.replace('"', '') + '</div>';
            $('#' + pages.register + '-htmlResponse').html(divContainer);
        });
    },

    logout: function () {
        userSettings.loginKey = '';
        userSettings.loginName = '';
        util.saveSettings();
        $('#' + pages.settings + '-lblPreLoginName').html(strings.notLoggedIn);
    },
    
    login: function () {

        var userName = $('#' + pages.login + '-txtUserName').val();
        var password = $('#' + pages.login + '-txtPassword').val();
        var appCode = util.getAppCode();
        var data = { userName: userName.trim(), password: password.trim(), appCode: appCode };
        ajaxHandler.load(searchType.login, data, function (json) {
            if (json.Success) {
                userSettings.loginKey = json.Data;
                userSettings.loginName = userName;
                util.saveSettings();
                phoneui.hideActivityDialog();
                phoneui.back();
            }
        });
    }

};

var ajaxHandler = {

    load: function (sType, paramData, callback) {
        try {
            var request = this.getRequest(sType, paramData);
            request.done(function (json) {
                phoneui.hideActivityDialog();
                if (json != undefined) {
                    if (callback)
                        callback(json);
                }
            });
            request.fail(function (jqXHR, textStatus) {
                phoneui.hideActivityDialog();
            });
        }
        catch (err) {
            phoneui.hideActivityDialog();
        }
    },

    getRequest: function (sType, paramData) {
        var urls = ['Mobile/GetSports', 'Mobile/GetLatest', 'Mobile/GetMyEvents', 'Mobile/GetMyProvidersAndEvents', 'Mobile/GetProviderEvents',
            'Message/SendMessageMobile', 'User/SendMessage', 'Mobile/Login', 'SGAccount/RegisterMobile', 'Message/GetMessage',
            'Message/GetEmptyMessage', 'Mobile/GetCourseDetailsLang', 'Mobile/ToggleLike', 'Mobile/GetDetails', 'User/AddOrRemoveUserEvent',
            'Mobile/GetCourseScheduleDates', 'User/GetGetUserMessages', 'User/GetUserEvents', 'Mobile/GetLatestDeals', 'Mobile/GetDeal'];
        var baseUrl = spscUrl;
        switch (sType) {
            case searchType.addOrRemoveUserEvent:
            case searchType.login:
            case searchType.mailbox:
            case searchType.myEvents:
            case searchType.myProviders:
            case searchType.register:
            case searchType.sendCourseMessage:
            case searchType.sendMessage:
                baseUrl = spscSecureUrl;
                break;
        }
        var url = urls[sType];
        var params = paramData;
        switch (sType) {
            case searchType.search:
                isEventSearch = searchSettings.selectedCategory == 1 ? true : false;
                params = listObj.createSearch();
                break;
            case searchType.latest:
                isEventSearch = false;
                params = { maxItems: MAXLATESTITEMS, locale: userSettings.locale };
                break;
            case searchType.myEvents:
                isEventSearch = true;
                params = this.getLoginParams();
                break;
            case searchType.myProviders:
                isEventSearch = false;
                params = this.getLoginParams();
                break;
            case searchType.providerEvents:
                isEventSearch = true;
                var data = util.getDetailsData();
                params = { id: data.Id };
                break;
            case searchType.sendCourseMessage:
                var data = $(":root").data(KEYCOURSEDETAILS);
                paramData.Id = data.Id;
                paramData.Key = userSettings.loginKey;
                paramData.Token = util.getAppCode();
                params = paramData;
                break;
            case searchType.getMessage:
                var data = util.getDetailsData();
                params = { messageType: 0, sportsUnitKey: data.Key, id: data.Id };
                break;
            case searchType.mailbox:
            case searchType.myCourses:
                params = this.getLoginParams();
                break;
        }
        phoneui.showActivityDialog(strings.search);
        var request = $.ajax({
            type: "POST",
            url: baseUrl + url,
            data: params,
            contentType: "application/x-www-form-urlencoded;charset=utf-8"
        });
        return request;
    },

    getLoginParams: function () {
        return { userkey: userSettings.loginKey, appKey: util.getAppCode() };
    }

};

var util = {

    renderList: function (container_id, data, callback) {
        var container = $("#" + container_id);
        var list = $("ul[class*=m1-list]", container);
        var clone = $("li:first", list).clone();
        var list_height = list.outerHeight();
        var length = data != null ? data.length : 0;
        if (length != 0) {
            $("li", list).remove();
            list.css('visibility', 'visible');
            var item = null;
            for (var i = 0; i < length; i++) {
                item = data[i];
                $(clone).removeClass("m1-first m1-last");
                if (i == 0)
                    $(clone).addClass("m1-first");
                if (i == length - 1)
                    $(clone).addClass("m1-last");
                $(clone).attr("data-listitem-index", i);
                if (callback)
                    callback(item, clone);
                list.append($(clone).clone());
            };
        }
        else
        {
            list.css('visibility', 'hidden');
        }
        var panel_ht = list_height * length + 15;
        $("div[id*=scroller]", container).attr("data-layout-content-height", panel_ht);
        phoneui.preprocessDOM(list);
        phoneui.forceLayout();

    },
    redraw: function () {  
        var field = document.createElement('input');
        field.setAttribute('type', 'text');
        document.body.appendChild(field);

        setTimeout(function() {
            field.focus();
            setTimeout(function() {
                field.setAttribute('style', 'display:none;');
            }, 50);
        }, 50);
    },

    guid: function () {
        function _p8(s) {
            var p = (Math.random().toString(16) + "000000000").substr(2, 8);
            return s ? "-" + p.substr(0, 4) + "-" + p.substr(4, 4) : p;
        }
        return _p8() + _p8(true) + _p8(true) + _p8();
    },

    getAppCode: function () {
        var appCode = userSettings.appCode;
        if (appCode == undefined || appCode == "") {
            userSettings.appCode = util.guid();
            util.saveSettings();
            appCode = userSettings.appCode;
        }
        return appCode;
    },

    gotoMultiPage: function (page, screen) {
        phoneui.gotoMultiPagePage(page + '-MainPages', 'SET_PAGE', page + '-' + screen, PAGETRANSITION);
    },

    gotoScreen: function (screen) {
        if (screen != lastPage) {
            phoneui.gotoScreen(screen, PAGETRANSITION);
        }
        lastPage = screen;
    },

    loadNoData: function (message) {

        $('#' + pages.nodata + '-txtMessage').html(message);
        util.gotoScreen(pages.nodata);
    },

    split: function (val) {
        return val.split(/,\s*/);
    },

    setSelectedEntry: function (page, list, value ) {
        $('#' + page + '-hidden-select-' + list).val(value);
        $('#' + page + '-' + list + ' li').removeClass('m1-selected');
        var selected = $('#' + page + '-' + list + ' li[data-val=' + value + ']');
        selected.addClass('m1-selected');
    },

    createSpScUrl: function (data) {
        var url = '';
        if (data != undefined) {
            var token = data.SportsUnitType != 1 ? '?Provider/' : '?Event/';
            var sp = data.SportList != '' ? data.SportList.split(', ').join('+').replace(new RegExp(" ", "g"), "+").replace(new RegExp("/", "g"), "_") : '-';
            var city = data.Location.City != '' ? data.Location.City.replace(new RegExp(" ", "g"), "+").replace(new RegExp("/", "g"), "_") : '-';
            var prettykey = data.PrettyKey != undefined ? data.PrettyKey.replace(new RegExp(" ", "g"), "+").replace(new RegExp("/", "g"), "_") : '-';
            url = token + city + '/' + sp + '/' + prettykey;
        }
        return url;
    },

    toggleImage: function(img, setActive)
    {
        var token = '.png';
        var replacer = '-inactive.png';
        var src = img.attr('src');
        if (setActive) {
            src = src.replace(replacer, token);
        }
        else {
            if (src.indexOf(replacer) == -1)
                src = src.replace(token, replacer);
        }
        img.attr('src', src);
    },

    extractLast: function (term) {
        return util.split(term).pop();
    },

    getElement: function (page, selector) {
        return $('#' + page + '-' + selector);
    },

    toggleVisibility: function (page, selector, visibility) {
        util.getElement(page, selector).css('visibility', visibility);
    },

    toggleButton: function (page, selector, enabled) {
        var el = util.getElement(page, selector);
        var img = $('img', el);
        if (img)
            this.toggleImage(img, enabled);
        if (enabled) {
            el.css('pointer-events', 'auto');
            el.find('.m1-text').css('color', 'black');
            el.attr('disabled', 'disabled');
        }
        else {
            el.css('pointer-events', 'none');
            el.find('.m1-text').css('color', 'grey');
            el.attr('disabled', 'disabled');
        }
    },


    showStaticContent: function (pageName) {
        var url = 'http://blog.sportscanner.net/content/app/' + userSettings.locale + '/' + pageName;
        $.get(url, function (data) {
            var element = $('#' + pages.staticContent + '-htmlData');
            element.html(data);
        });
    },

    setItem: function (page, selector, labelSelector, value, showAlways) {
        
        var element = util.getElement(page, selector);
        value = value != 'null' && value != null && value != '' ? value : '';
        
        if (element.text != undefined)
            element.text(value);
        else if (element.html != undefined)
            element.html(value);
        if (value != '') {
            util.toggleVisibility(page, selector, 'visible');
            if (labelSelector != null) util.toggleVisibility(page, labelSelector, 'visible');
            
        }
        else {
            if(showAlways == undefined)
                util.toggleVisibility(page, selector, 'hidden');
            if (labelSelector != null) util.toggleVisibility(page, labelSelector, 'hidden');
        }
    },

    fillSearchMessage: function(page, message) {
        var lbl1 = $('#' + page + '-lblSearchMessage1');
        var lbl2 = $('#' + page + '-lblSearchMessage2');
        if(message == undefined)
        {
            var width = lbl1.parent().outerWidth();
            var length = searchSettings.placeName.length;
            var placeName = $.trim(searchSettings.placeName).substring(0, 33).trim(this) + "...";
            
            lbl1.html(strings.searchIn + ' ' + placeName + ' ' + strings.distance + ' ' + searchSettings.distance + ' ' + strings.distanceUnit);
            var cat = searchSettings.selectedCategoryName != '' ? ' (' + searchSettings.selectedCategoryName + ')' : '';
            if (lbl2 != undefined)
                lbl2.html(strings.sport + ' ' + searchSettings.sportsText + cat);
        }
        else
        {
            lbl1.html(message);
            if (lbl2 != undefined)
                lbl2.html('');
        }
    },

    load: function (key) {
        return JSON.parse(localStorage.getItem(key));
    },
    save: function (key, data) {
        localStorage.removeItem(key);
        localStorage.setItem(key, JSON.stringify(data));
        return true;
    },
    remove: function (key) {
        if (key in localStorage) localStorage.removeItem(key);
    },

    loadSettings: function () {

        var setting = JSON.parse(localStorage.getItem(KEYUSERSETTINGS));
        if(setting != undefined)
            userSettings = setting;
      if (userSettings.appVersion != currentVersion)
      {
           util.remove(KEYLANGUAGE);
            util.remove(KEYLANGUAGESPORT);
            util.remove(KEYDETAILS);
            util.remove(KEYLOCALE);
            userSettings.appVersion = currentVersion;
            util.saveSettings();
         }
        if(userSettings.saveSearchSettings)
        {
            $('#' + pages.settings + '-chkSaveSearchSettings input').attr('checked','checked');
            setting = JSON.parse(localStorage.getItem(KEYSEARCHSETTINGS));
            if(setting != undefined)
                searchSettings = setting;
            $('#' + pages.sportscanner + '-txtLocation').val(searchSettings.placeName);
            $('#' + pages.detailSearch + '-txtLocation').val(searchSettings.placeName);
            $('#' + pages.courseSearch + '-txtLocation').val(searchSettings.placeName);
            $('#' + pages.detailSearch + '-txtCurrentCategorie').text(searchSettings.selectedCategoryName);
            $('#' + pages.detailSearch + '-txtSports').text(searchSettings.sportsText);
            $('#' + pages.detailSearch + '-txtCurrentDistance').text(searchSettings.distanceText);
            $('#' + pages.detailSearch + '-txtCustomText').val(searchSettings.searchText);
            $('#' + pages.courseSearch + '-txtCustomText').val(searchSettings.searchText);
            util.setSelectedEntry(pages.selectCategory, 'lstCategories', searchSettings.selectedCategory);
            util.setSelectedEntry(pages.selectDistance, 'lstDistance', searchSettings.distance);
            $('#' + pages.sportscanner + '-txtCurrentDistance').text(searchSettings.distance + ' km');
        }
        else
        {
            $('#' + pages.settings + '-chkSaveSearchSettings input').removeAttr('checked');
        }
        
    },

    saveSettings: function() {
        localStorage.removeItem(KEYUSERSETTINGS);
        localStorage.setItem(KEYUSERSETTINGS, JSON.stringify(userSettings));
        if(userSettings.saveSearchSettings)
        {
            localStorage.removeItem(KEYSEARCHSETTINGS);
            localStorage.setItem(KEYSEARCHSETTINGS, JSON.stringify(searchSettings));
        }
    },

    toggle: function (authenticated, gotoPage) {
        util.toggleVisibility(pages.sportscanner, 'cmdRegister', 'visible');
        if (authenticated) {
            util.toggleVisibility(pages.sportscanner, 'toolbar_logged_in', 'visible');
            util.toggleVisibility(pages.sportscanner, 'toolbar_anonymous', 'hidden');
            util.toggleVisibility(pages.sportscanner, 'cmdLogin', 'hidden');
            util.toggleVisibility(pages.sportscanner, 'cmdRegister', 'hidden');
        }
        else {
            util.toggleVisibility(pages.sportscanner, 'toolbar_logged_in', 'hidden');
            util.toggleVisibility(pages.sportscanner, 'toolbar_anonymous', 'visible');
            util.toggleVisibility(pages.sportscanner, 'cmdLogin', 'visible');
            util.toggleVisibility(pages.sportscanner, 'cmdRegister', 'visible');
        };
        if (gotoPage !== undefined) {
            phoneui.gotoMultiPagePage(pages.sportscanner + '-MainPages', 'SET_PAGE', pages.sportscanner + '-Startup', 'FADE');
        }
    },

    getDetailsData: function () {
        return $(":root").data(providerEventMode ? KEYEVENTDETAILS : KEYDETAILS);
    },

    getListData: function () {
        return $(":root").data(providerEventMode ? KEYEVENTLIST : KEYRESULT);
    },

    saveDetailsData: function (data) {
        return $(":root").data(providerEventMode ? KEYEVENTDETAILS : KEYDETAILS, data);
    },

    saveListData: function (data) {
        return $(":root").data(providerEventMode ? KEYEVENTLIST : KEYRESULT, data);
    },

    getListPage: function () {
        return (providerEventMode || isEventSearch) ? pages.eventList : pages.resultList;
    }

};

var mailMessage = {

    loadMessageDetails: function (element, mailbox) {
        var selItem = $(element).closest('li[data-listitem-index]');
        var index = $(selItem).attr("data-listitem-index");
        var data = $(":root").data(KEYMAILBOX);
        var resultList = null;
        if (mailbox == mailboxType.inbox)
            resultList = data.InBox;
        else
            resultList = data.OutBox;
        var item = resultList[index];
        util.gotoScreen(pages.mailContent);
        util.setItem(pages.mailContent, 'txtUser', null, item.Fm);
        util.setItem(pages.mailContent, 'txtSubject', null, item.Su);
        util.setItem(pages.mailContent, 'txtContent', null, item.Mt);
        util.setItem(pages.mailContent, 'txtReceivedDate', null, item.Dt);
    },

    openMessageScreen: function (page, sType) {
        ajaxHandler.load(sType, null, function (json) {
            $(":root").data(KEYMAILMESSAGE, json);
            var msg = '';
            if (sType == searchType.getMessage) {
                var data = util.getDetailsData();
                msg = strings.messageTo + ' ' + data.Name;
            }
            else {
                var data = $(":root").data(KEYCOURSEDETAILS);
                msg = strings.messageTo + ' ' + data.Evt.Nm;
            }
            util.setItem(page, 'lblName', null, msg);
             
            util.gotoScreen(page);
        });
    },

    sendMessage: function (page, sType) {
        var data = $(":root").data(KEYMAILMESSAGE);
        if (sType == searchType.sendMessage) {
            data.SenderEmail = $('#' + page + '-txtMailAdress').val();
        }
        data.MessageSubject = $('#' + page + '-txtSubject').val();
        data.MessageText = $('#' + page + '-txtContent').val();
        ajaxHandler.load(sType, data, function (json) {
            var color = '#f11d1d';
            if (json.Success) {
                color = '#0b7c0e';
                $('#' + page + '-txtSubject').val('');
                $('#' + page + '-txtMailAdress').val('');
                $('#' + page + '-txtContent').val('');
            }
            var divContainer = '<div style="color:' + color + ';font-size:12px;">' + json.ReturnStateMessage.replace('"', '') + '</div>';
            $('#' + page + '-htmlResponse').html(divContainer);
        });
    },

    loadMailbox: function (reload) {
        ajaxHandler.load(searchType.mailbox, null, function (json) {
            if (json.Success) {
                $(":root").data(KEYMAILBOX, json.Data);
                mailMessage.renderInbox();
                mailMessage.renderOutbox();
                if(reload)
                    util.gotoScreen(pages.mailbox);
            }
            else  {
                util.loadNoData(strings.alertMailboxEmpty);
            } 
        });
    },

    renderOutbox: function () {
        var data = $(":root").data(KEYMAILBOX);
        var container_id = pages.mailbox + '-PageOutbox';
        util.renderList(container_id, data.OutBox, function (item, clone) {
            $("div[id*=txtUser]", clone).text(item.To);
            $("div[id*=txtSubject]", clone).text(item.Su);
            $("div[id*=txtDate]", clone).text(item.Dt);
        });
    },

    renderInbox: function () {
        var data = $(":root").data(KEYMAILBOX);
        var container_id = pages.mailbox + '-PageInbox';
        util.renderList(container_id, data.InBox, function (item, clone) {
            $("div[id*=txtUser]", clone).text(item.Fm);
            $("div[id*=txtSubject]", clone).text(item.Su);
            $("div[id*=txtDate]", clone).text(item.Dt);
        });
    },

};

var sports = {

    searchSports: function () {
        var value = $('#' + pages.selectSports + '-textSportSearch').val().trim();
        if(value.length > 2 || !allSportVisible)
        {
            allSportVisible = true;
            var length = 0;
            $('#' + pages.selectSports + '-lstSports > li').each(function() {
                if ($('div', this).text().toLowerCase().search(value.toLowerCase()) > -1) {
                    length++;
                    $(this).show();
                }
                else {
                    $(this).hide();
                    allSportVisible = false;
                }
            });
            var container = $("#" + pages.selectSports + '-pnlSports');
            var list = $("ul[class*=m1-list]", container);
            var list_height = $('#' + pages.selectSports + '-lstSports > li:first').outerHeight();
            var panel_ht = list_height * length + 15;
            $("div[id*=scroller]", container).attr("data-layout-content-height", panel_ht);
            list.scrollTop(0);
            phoneui.preprocessDOM(list);
            phoneui.forceLayout();
        }
    }, 

    fillsportsList: function () {
        if(!sportsLoaded) {
            var sportData = JSON.parse(localStorage.getItem(KEYSPORTS));
            sports.renderSportList(pages.selectSports + '-pnlSports', sportData);
        }
    },

    showCategories: function (src) {
        var selItem = $(src).closest('li[data-listitem-index]');
        var id = $(selItem).attr("data-listitem-index");
        var text = $('div', selItem).text();
        $('#' + pages.detailSearch + '-txtSports').text(text);
        searchSettings.sports = [];
        searchSettings.sports.push(id);
        searchSettings.sportsText = text;
        sports.searchSports();
        util.fillSearchMessage(pages.selectCategory);
        if (useWizard)
            util.gotoScreen(pages.selectCategory);
        else {
            util.gotoScreen(pages.detailSearch);
        }
    },

    renderSportList: function (container_id, sportData) {
        var container = $("#" + container_id);
        var list = $("ul[class*=m1-list]", container);
        var clone = $("li:first", list).clone();
        var list_height = list.outerHeight();
        var length = 0;
        var data = sportData.TranslationList[0].Translations;
        list.css('visibility', 'visible');
        $("li", list).remove();
        length = data.length;
        if (length != 0) {
            var item = null;
            this.addItem(clone, 0, strings.all);
            list.append($(clone).clone());
            for (var i = 0; i < length; i++) {
                item = data[i];
                this.addItem(clone, item.nm, item.vl);
                list.append($(clone).clone());
            };
            var panel_ht = list_height * length + 15;
            $("div[id*=scroller]", container).attr("data-layout-content-height", panel_ht);
            phoneui.preprocessDOM(list);
            phoneui.forceLayout();
        };
        sports.searchSports();
        sportsLoaded = true;
    },

    clearSportSearch: function() {
        $('#' + pages.selectSports + '-textSportSearch').val('');
        searchSettings.sports = [];
        searchSettings.sportsText = '';
        util.saveSettings();
        sports.searchSports();
    },

    addItem: function (clone, id, name) {
        $(clone).removeClass("m1-first m1-last");
        $(clone).attr("data-listitem-index", id);
        $("div[id*=txtSportName]", clone).text(name);
    },
};

var userLocation = {

    renderMap: function (data, mapElement) {
        var bounds = new google.maps.LatLngBounds();
        var counter = 0;
        var setYouAreHereMarker = false;
        var pos = null;
        var imageName = 'marker_0.png';

        if (searchSettings.longitude != "" && searchSettings.latitude != "") {
            pos = new google.maps.LatLng(searchSettings.latitude, searchSettings.longitude);
            setYouAreHereMarker = true;
            bounds.extend(pos);
            counter++;
        }
        else {
            if(data !== undefined)
                pos = new google.maps.LatLng(data[0].Latitude, data[0].Longitude);
        }  
        var myOptions = {
            zoom: 15,
            center: pos,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        };
        var largeMap = new google.maps.Map(document.getElementById(mapElement), myOptions);
        largeMap.setCenter(pos);
        if (setYouAreHereMarker) {
            var centermarker = new google.maps.Marker({
                map: largeMap,
                position: pos
            });
            centermarker.setIcon('images/' + imageName);
        }
        $.each(data, function (key, value) {
            if (value.Latitude != 0 && value.Longitude != 0) {
                var position = new google.maps.LatLng(value.Latitude, value.Longitude);
                bounds.extend(position);
                counter++;
                var marker = new google.maps.Marker({
                    map: largeMap,
                    position: position,
                    title: value.Name
                });
                imageName = 'marker_' + value.SportsUnitType + '.png';
                marker.setIcon('images/' + imageName);
                google.maps.event.addListener(marker, "click", function (event) {
                    detailsObj.loadDetailsForItem(value);
                });
            };
        });
        if (counter > 1) {
            largeMap.fitBounds(bounds);
        }

        var x = largeMap.getZoom();
        phoneui.preprocessDOM();
        phoneui.forceLayout();
        phoneui.hideActivityDialog();
        return true;
    },

    setLocationAutoComplete: function (selectorName) {
        try {
            var options = {
                types: ['geocode']
            };
            var input = document.getElementById(selectorName);
            var autocomplete = new google.maps.places.Autocomplete(input, options);
        }
        catch (err) {
        };
    },

    geoCode: function (coder, callback) {
        phoneui.showActivityDialog(strings.search);
        var geocoder = new google.maps.Geocoder({ 'language': glob_locale });
        geocoder.geocode(coder, function (results, status) {
            if (status == google.maps.GeocoderStatus.OK) {
                $('.pac-container .pac-item:first').text('');
                $('#' + pages.sportscanner + '-txtLocation').val(results[0].formatted_address);
                $('#' + pages.detailSearch + '-txtLocation').val(results[0].formatted_address);
                $('#' + pages.courseSearch + '-txtLocation').val(results[0].formatted_address);
                searchSettings.latitude = results[0].geometry.location.lat();
                searchSettings.longitude = results[0].geometry.location.lng();
                searchSettings.placeName = results[0].formatted_address;
                if (callback != null)
                    callback();
            }
            else {
                phoneui.hideActivityDialog();
            }

        });
    },

    getUserLocation: function (callback) {
        var errorText = strings.errorTextSearch;
        var currentPage = util.getListPage();
        try {
            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(function (position) {
                    if (position !== undefined) {
                        if (position.coords.accuracy < 200) {
                            if (google != undefined) {
                                var latlng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
                                userLocation.geoCode({ 'latLng': latlng }, callback);
                            }
                            else
                                util.fillSearchMessage(currentPage, errorText, true);
                        }
                        else {
                            util.fillSearchMessage(currentPage, errorText, true);
                        };
                    };
                }, function (error) {
                    util.fillSearchMessage(currentPage, errorText, true);
                    phoneui.hideActivityDialog();
                },
            { enableHighAccuracy: true, timeout: 10000, maximumAge: 0 });
            };
        }
        catch (err) {
            util.fillSearchMessage(currentPage, errorText, true);
            phoneui.hideActivityDialog();
        }
    }
};

var listObj = {

    defaultDistance: 20,

    hideList: function (container_id) {
        var container = $("#" + container_id);
        var list = $("ul[class*=m1-list]", container);
        list.css('visibility', 'hidden');
    },

    renderList: function (container_id) {
        var data = util.getListData();
        util.renderList(container_id, data, function ( item, clone ) {
            $("div[id*=txtHeader]", clone).text(item.Name);
            $("div[id*=txtSports]", clone).text(item.SportList);
            $("div[id*=txtCity]", clone).text(item.City);
            if (item.SportsUnitType == 1)
                $("div[id*=txtDate]", clone).text(item.FormattedDate)
                else $("div[id*=txtDate]", clone).text(''); 
            var distance = item.Distance != '0' ? item.Distance : '';
            $("div[id*=txtDistance]", clone).text(distance !== '' ? distance + ' km' : '');
            $("img[id*=img]", clone).attr("src", 'images/marker_' + item.SportsUnitType + '.png');
            $("div[id*=txtHeader]", clone).css("overflow", "hidden");
            $("div[id*=txtSports]", clone).css("overflow", "hidden");
            $("div[id*=txtCity]", clone).css("overflow", "hidden");
        });
        util.fillSearchMessage(util.getListPage(), $(":root").data(KEYMESSAGE))
    },

    renderMap: function (currentPage) {
        var data = util.getListData();
        userLocation.renderMap(data, currentPage + '-largeMap');
        util.toggleVisibility(currentPage, 'pnlResultMap', 'visible');
    },

    emptyMessage: function (page, element) {
        var currentPage = util.getListPage();
        var container = $("#" + page + '-' + element);
        var list = $("ul[class*=m1-list]", container);
        list.css('visibility', 'hidden');
        var resultText = $(":root").data(KEYMESSAGE);
        lastView = viewType.list;
        util.gotoMultiPage(currentPage, 'resultList');
        
        util.toggleVisibility(currentPage, 'pnlResultList', 'hidden');
        util.fillSearchMessage(page, resultText, false);
        phoneui.preprocessDOM(list);
        phoneui.forceLayout();
        phoneui.hideActivityDialog();
    },

    createSearch: function() {
        var index = searchSettings.selectedCategory - 1;
        var searchCategories = index == -1 ? sportsCategories : categoriesEmpty.slice();
        if(index != -1){ 
            searchCategories[index] = 1;
        }
        var search = { Latitude: searchSettings.latitude, 
            Longitude: searchSettings.longitude,
            Distance: searchSettings.distance != 0 ? searchSettings.distance : this.defaultDistance, 
            SelectedItemsString: searchCategories != undefined ? searchCategories.join(',') : '', 
            Location: searchSettings.placeName, 
            SubType: searchSettings.sports != '0' ? searchSettings.sports.join(',') : '',
            Name: searchSettings.searchText,
            OnlyCourseProviders: onlyCourseProvider
        };
        return search;
    },

    createMessage: function (sType, json) {
        var msg = json.ResultCount > 1 ? json.ResultCount.toString() + ' ' + strings.entriesFound : strings.singleEntryFound;
        switch (sType) {
            case searchType.latest:
                msg = MAXLATESTITEMS + ' ' + strings.latestEntries;
                break;
            case searchType.search:
                if (json.ResultCount.toString() != json.ReturnStateMessage) {
                    msg = strings.moreentriesFound.format(json.ResultCount.toString());
                }
                break;
        }
        $(":root").data(KEYMESSAGE, msg);
    },

    load: function (sType, list) {
        var currentPage = list == undefined ? util.getListPage() : list;
        ajaxHandler.load(sType, null, function (json) {
            if (json.Success) {
                util.saveListData(json.ResultList);
                listObj.createMessage(sType, json);
                util.gotoScreen(currentPage);
                listObj.hideList(currentPage + '-pnlResult');
                util.toggleVisibility(currentPage, 'pnlResultMap', 'hidden');
                listObj.toggleView(viewType.list, true, list);
                phoneui.hideActivityDialog();
            }
            else {
                switch(sType)
                {
                    case searchType.myEvents:
                        
                        break;
                }
                $(":root").data(KEYMESSAGE, json.ReturnStateMessage);
                util.saveListData(null);
                util.gotoScreen(currentPage);
                listObj.hideList(currentPage + '-pnlResult');
                util.toggleVisibility(currentPage, 'pnlResultMap', 'hidden');
                listObj.emptyMessage(util.getListPage(), 'pnlResultList');
                phoneui.hideActivityDialog();
            }
        });
    },

    setSelectedCategory: function (src) {
        var selItem = $(src).closest('li');
        var id = selItem.attr('data-val');
        searchSettings.selectedCategory = id;
        searchSettings.selectedCategoryName = $('label', selItem).html();
    },

    getProviderEvents: function () {
        providerEventMode = false;
        var data = util.getDetailsData();
        if (data.Events != null ? data.Events.length > 0 : false) {
            
            providerEventMode = true;
            var currentPage = util.getListPage();
            util.gotoScreen(currentPage);
            listObj.hideList(currentPage + '-pnlResult');
            util.toggleVisibility(currentPage, 'pnlResultMap', 'hidden');
            util.saveListData(data.Events);
            var msg = data.Events.length > 1 ? data.Events.length.toString() + ' ' + strings.entriesFound : strings.singleEntryFound;
            $(":root").data(KEYMESSAGE, msg);
            this.toggleView(viewType.list, true);
        }
    },

    startSearch: function () {
        try 
        {

            if (useWizard){
                $('#' + pages.detailSearch + '-txtLocation').val($('#' + pages.sportscanner + '-txtLocation').val());
            }
            else {
                $('#' + pages.sportscanner + '-txtLocation').val($('#' + pages.detailSearch + '-txtLocation').val());
            }
            var placeName = $('#' + pages.detailSearch + '-txtLocation').val();
            if (searchSettings.placeName == '' && placeName == '' && searchSettings.searchText == '') {
                phoneui.showActivityDialog(strings.search);
                util.saveSettings();
                this.loadCurrentLocationList();
               }
            else {
                    phoneui.showActivityDialog(strings.search);
                    util.saveSettings();
                    this.loadList();
            }
        }
        catch (err){
            phoneui.hideActivityDialog();
        }
    },

    loadCurrentLocationList: function () {
        userLocation.getUserLocation(function () { listObj.load(searchType.search); });
    },

    loadList: function () {
        var firstResult = $('#' + pages.sportscanner + '-txtLocation').val();
        if (firstResult == '') {
            firstResult = $('.pac-container .pac-item:first').text();
        }
        if (firstResult != '' && firstResult != undefined) {
            userLocation.geoCode({ 'address': firstResult }, function () {
                listObj.load(searchType.search);
            });
        }
        else {
            listObj.load(searchType.search);
        }
    },

    toggleView: function (vType, render, list) {
        lastView = vType
        var currentPage = list == undefined ? util.getListPage(): list;
        util.gotoScreen(currentPage);
        if (vType == viewType.list) {
            util.gotoMultiPage(currentPage, 'resultList');
            util.toggleVisibility(currentPage, 'pnlResultList', 'visible');
           if (render)
                this.renderList(currentPage + '-pnlResultList');
        }
        else {
            util.gotoMultiPage(currentPage, 'resultMap');
            util.toggleVisibility(currentPage, 'pnlResultMap', 'visible');
            if (render)
                this.renderMap(currentPage);
        }
     }
 };

function detailsImpl() {

    var pageToShow = pages.details;
    var sportsUnitTypeEvent = 1;

    var fillDetails = function () {
        
        var data = util.getDetailsData();
        var street = '{0} {1}'.format(data.Location.Street, data.Location.StreetNumber).trim();
        var city = '{0} {1}'.format(data.Location.ZipCode, data.Location.City).trim();
        if (data.IsInOwnerList) {
            util.toggleImage($('#' + pageToShow + '-cmdLike'), true);
        }
        else
            util.toggleImage($('#' + pageToShow + '-cmdLike'), false);
        util.setItem(pageToShow, 'lblName', null, data.Name);
        util.setItem(pageToShow, 'lblStreet', null, street);
        util.setItem(pageToShow, 'lblCity', null, city);
        util.setItem(pageToShow, 'lblSports', null, data.SportList);
        util.setItem(pageToShow, 'lblUrl', null, data.WebSite);
        util.setItem(pageToShow, 'lblEmail', null, data.Email);
        util.toggleVisibility(pageToShow, 'lblUrl', 'hidden');
        util.toggleVisibility(pageToShow, 'lblEmail', 'hidden');
        if (data.SportsUnitType == sportsUnitTypeEvent) {
            if (data.MembersOnly)
                util.setItem(pageToShow, 'lblMembersOnly', null, strings.membersOnly);
            util.setItem(pageToShow, 'lblProviderName', null, data.ProviderName);
            util.setItem(pageToShow, 'lblMaxAttendee', null, data.MaxParticipants);
            util.setItem(pageToShow, 'lblPrice', null, data.FormattedPrice);
            var container_id = pageToShow + '-pnlResultList';
            util.renderList(container_id, data.EventDates, function (item, clone) {
                $("div[id*=txtDate]", clone).text(item.FormattedDate);
            });
            util.toggleButton(pageToShow, 'btnProvider', data.Provider_Id !== 0);
        }
        else {
            util.setItem(pageToShow, 'lblOpenTimes', null, data.BusinessHours);
            util.setItem(pageToShow, 'lblPhone', null, data.PhoneNumber);
            util.setItem(pageToShow, 'lblFax', null, data.FaxNumber);
            util.setItem(pageToShow, 'lblCategory', null, data.SportsUnitTypeName);
            util.toggleButton(pageToShow, 'btnCall', data.PhoneNumber !== '');
            util.toggleButton(pageToShow, 'cmdCourses', data.HasCourses == true);
            util.toggleButton(pageToShow, 'cmdEvents', data.Events !== undefined && data.Events !== null ? data.Events.length > 0 : false);
        }
        
        var logoUrl = null;
        logoUrl = getLogo(data);
        var imageStyle = 'width:133px;height:166px;line-height:50px;text-align:center;overflow:visible;background-image: url("' + logoUrl + '"); background-size: 100% auto; background-repeat: no-repeat;';
        $('#' + pageToShow + '-pnlImage').attr('style', imageStyle);
        util.setItem(pageToShow  , 'lblDescription', null, data.Description, true);  
           
        
        util.toggleButton(pageToShow, 'btnShowMailFrm', data.Email !== '');
        util.toggleButton(pageToShow, 'btnOpenWeb', data.WebSite !== '');
        
        util.toggleButton(pageToShow, 'btnPictures', data.Images !== null ? data.Images.length > 0 : false);
        util.toggleVisibility(pageToShow, 'pnlResult', 'visible');
        phoneui.preprocessDOM();
    };

    var getLogo = function (data) {
        var returnValue = null;
        $.each(data.Images, function (index, item) {
            if(item.IsLogo)
                returnValue = spscUrl + uploadHandlerUrl + '?f=' + encodeURIComponent(item.ImageUrl) + '&id=' + data.Key + '&thumbnail=true';
                return;
        });
        return returnValue;
    };
    
    this.loadDetails = function (element) {
        var selItem = $(element).closest('li[data-listitem-index]');
        var index = $(selItem).attr("data-listitem-index");
        resultList = util.getListData();
        $(":root").data(KEYINDEX, index);
        var item = resultList[index];
        pageToShow = item.SportsUnitType == sportsUnitTypeEvent ? pages.detailsEvent : pages.details
        this.loadDetailsForItem(item);
    };

    this.openEventProvider = function () {
        
        var item = util.getDetailsData();
        providerEventMode = false;
        this.loadDetailsForItem({ Id: item.Provider_Id, Distance: 0, SportsUnitType: 2 })
    };

    this.toggleLike = function () {
        var item = util.getDetailsData();
        var state = !item.IsInOwnerList;
        if(item != undefined)
        {
            var data = { id: item.Id, userKey: userSettings.loginKey, appKey: util.getAppCode(), like: state };
            ajaxHandler.load(searchType.toggleLike, data, function (json) {
                if (json.Success) {
                    util.toggleImage($('#' + pageToShow + '-cmdLike'), state);
                    item.IsInOwnerList = state;
                    util.saveDetailsData(item);
                }
            });
        }
    };

    this.loadDetailsForItem = function (item) {

        pageToShow = item.SportsUnitType == sportsUnitTypeEvent ? pages.detailsEvent : pages.details
        util.toggleVisibility(pageToShow, 'pnlDetails', 'hidden');
        util.toggleVisibility(pageToShow, 'pnlDetailsMap', 'hidden');
        phoneui.showActivityDialog(strings.search);
        var data = { id: item.Id, distance: 0, sportsUnitType: item.SportsUnitType };
        ajaxHandler.load(searchType.details, data, function (json) {
            if (json.Success) {
                if(json.Data.SportsUnitType != sportsUnitTypeEvent)
                {
                    analytics.write(json.Data.Name, "Details");
                }
                else
                {
                    analytics.write(json.Data.ProviderName, json.Data.Name);
                }
                util.saveDetailsData(json.Data);
                lastProviderId = json.Data.Id;
                lastProviderName = json.Data.Name;
                detailsObj.toggleView(viewType.details, true);
            }
        });
    };

    this.share = function () {
        var details = util.getDetailsData();
        var url = util.createSpScUrl(details)
        phoneui.composeEmailFromPage($('#' + pageToShow), '', strings.share1 + ' ' + details.Name, strings.share2 + '\r\n' + strings.share3 + ' ' + details.Name + '\r\n\r\n' + spscUrl + url + '\r\n\r\n' + strings.share4);
    };

    var renderMap = function () {
        var data = util.getDetailsData();
        var arrData = [];
        arrData[0] = { Latitude: data.Location.Latitude, Longitude: data.Location.Longitude, Name: data.Name, SportsUnitType : data.SportsUnitType, Id: data.Id};
        userLocation.renderMap(arrData, pageToShow + '-map');
    };

    this.toggleView = function (vType, render) {
        lastDetailsView = vType;
        util.gotoScreen(pageToShow);
        if (vType == viewType.details) {
            util.gotoMultiPage(pageToShow, 'pageDetails');
            util.toggleVisibility(pageToShow, 'pnlDetails', 'visible');
            if (render)
                fillDetails();
        }
        else {
            util.gotoMultiPage(pageToShow, 'pageMap');
            util.toggleVisibility(pageToShow, 'pnlDetailsMap', 'visible');
            renderMap();
        }
     }
};

var courses = {

    loadMyCourses: function () {
        ajaxHandler.load(searchType.myCourses, null, function (json) {
            if (json.Success) {
                $(":root").data(KEYDAYCOURSES, json.Data);
                lastProviderId = userSettings.providerId;
                lastProviderName = userSettings.providerName;
                courses.renderMyCourses();
                util.gotoScreen(pages.myCourses);
            }
            else  {
                util.loadNoData(strings.alertNoCourses);
            }
        });
    },
    
    // Tom 
    refreshMyCourses: function () {
        ajaxHandler.load(searchType.myCourses, null, function (json) {
            if (json.Success) {
                $(":root").data(KEYDAYCOURSES, json.Data);
                lastProviderId = userSettings.providerId;
                lastProviderName = userSettings.providerName;
                courses.renderMyCourses();
            }
            else  {
                util.loadNoData(strings.alertNoCourses);
            }
        });
    },
    

    renderMyCourses: function () {
        var data = $(":root").data(KEYDAYCOURSES);
        var container_id = pages.myCourses + '-pageAgenda';
        util.renderList(container_id, data, function (item, clone) {
            $("div[id*=txtName]", clone).text(item.Evt.Nm);
            $("div[id*=txtRoom]", clone).text('Ort: '+item.Pl);
            $("div[id*=txtCourseDate]", clone).text(item.Dy);
            $("div[id*=txtProvider]", clone).text(item.Evt.Pv);
        });
    },

    addOrRemoveUserEvent: function () {
        var key = userSettings.loginKey;
        if (key != '') {
            var courses = $(":root").data(KEYCOURSEDETAILS);
            var data =  { eventDateId: courses.Id, userKey: key, appKey: util.getAppCode() };
            ajaxHandler.load(searchType.addOrRemoveUserEvent, data, function (json)  {
                if (json.Success) {
                    util.toggleImage($('#' + pages.courseDetails + '-cmdThumbsUp'), json.Data);
                    util.setItem(pages.courseDetails, 'lblAttend', null, json.Data ? strings.thumbsUp : strings.thumbsDown);
                }
            });
        }
        else {
            userLogin.load();
        }
    },

    getDayData: function(day){
        var data = $(":root").data(KEYCOURSES);
        var returnValue = null;
        $.each(data, function (key, value) {
            var item = value[0];
            if(item.Dow == day)
                returnValue = value;
                return;
        })
        return returnValue;
    },

    saveCourses: function () {
        if (lastProviderId != userSettings.providerId)
        {
            var data = $(":root").data(KEYCOURSES);
            userSettings.providerId = lastProviderId;
            userSettings.providerName = lastProviderName;
            util.saveSettings();
            util.save(KEYCOURSES, data);
            $('#' + pages.courses + '-cmdMyCourses').html(strings.myCourses);
            util.toggleImage($('#' + pages.courses + '-cmdMyCourse'), true);
        }
        else
        {
            userSettings.providerId = 0;
            userSettings.providerName = '';
            util.saveSettings();
            util.remove(KEYCOURSES);
            $('#' + pages.courses + '-cmdMyCourses').html(strings.notMyCourses);
            util.toggleImage($('#' + pages.courses + '-cmdMyCourse'), false);
        }
    },


    renderList: function (container_id, day) {
        $('#' + pages.courses + '-lblStudioName').html(lastProviderName);
        var data = this.getDayData(day);
        $(":root").data(KEYDAYCOURSES, data);
        var cmdMyCourses = $('#' + pages.courses + '-cmdMyCourses')
        if (lastProviderId == userSettings.providerId)
        {
            cmdMyCourses.html(strings.myCourses);
            util.toggleImage($('#' + pages.courses + '-cmdMyCourse'), true);
        }
        else
        {
            cmdMyCourses.html(strings.notMyCourses);
            util.toggleImage($('#' + pages.courses + '-cmdMyCourse'), false);
        }
        util.renderList(container_id, data, function (item, clone) {
            var filterCategory = item.Evt.Tp.split('-');
            $("div[id*=txtName]", clone).text(item.Evt.Nm);
            $("div[id*=txtCourseCategorie]", clone).text(filterCategory[0].trim());
            $("div[id*=txtParticipants]", clone).text(item.Evt.Pt);
            $("div[id*=txtCoach]", clone).text(item.Evt.Co);
            $("div[id*=txtRoom]", clone).text(item.Pl);
            $("div[id*=txtTime]", clone).text(item.Rg);
        });
        this.highlightButton(day);
    },

    highlightButton: function (day) {
        $('[id*=-day-]').removeClass(HIGHLIGHTEDCLASS);
        $('#' + pages.courses + "-day-" + day).addClass(HIGHLIGHTEDCLASS);
        phoneui.preprocessDOM();
        phoneui.forceLayout();
    },

    showMyCourseSchedule: function () {
        var data = util.load(KEYCOURSES);
        lastProviderId = userSettings.providerId;
        lastProviderName = userSettings.providerName;
        if (data != undefined) {
            $(":root").data(KEYCOURSES, data);
            util.gotoScreen(pages.courses);
            this.getDayAndRender();
        } 
        else
        {
            util.gotoScreen(pages.courseSearch);
        }
        
    },

    showCourses: function(day) {
        this.highlightButton(day);
        courses.renderList(pages.courses + '-pnlResult', day);
    },

    refreshMyCourses: function () {
        lastProviderId = userSettings.providerId;
        lastProviderName = userSettings.providerName;
        courses.loadCourseSchedule(function () {
            var data = $(":root").data(KEYCOURSES);
            util.save(KEYCOURSES, data);
        });
    },

    getCourses: function () {
        courses.loadCourseSchedule(function () {
            util.gotoScreen(pages.courses);
            courses.getDayAndRender();
        });
    },

    loadCourseSchedule: function( callback ) {
        var providerId = lastProviderId;
        if (providerId != 0 && providerId != undefined) {
            var data = { providerId: providerId };
            ajaxHandler.load(searchType.getCourses, data, function (json) {
                analytics.write(lastProviderName, 'Courses');
                $(":root").data(KEYCOURSES, json);
                if (callback)
                    callback();
                
            });
        }
    },

    getDetails: function (element) {
        var data = $(":root").data(KEYDAYCOURSES);
        var selItem = $(element).closest('li[data-listitem-index]');
        var index = $(selItem).attr("data-listitem-index")
        var courseId = data[index].Id;
        if (courseId != 0 && courseId != undefined) {
            //var data = { id: courseId, userKey: userSettings.loginKey, appKey: util.getAppCode() };
            var data = { id: courseId, userKey: userSettings.loginKey, appKey: util.getAppCode(), locale: userSettings.locale };
            ajaxHandler.load(searchType.courseDetails, data, function (json) {
                $(":root").data(KEYCOURSEDETAILS, json);
                lastCourseId = courseId;
                analytics.write(lastProviderName, json.Evt.Nm);
                courses.renderDetails();
            });
        };
    },

    renderDetails: function () {
        var data = $(":root").data(KEYCOURSEDETAILS);
        var filterCategory = data.Evt.Tp.split('-');
        util.gotoScreen(pages.courseDetails);
        util.setItem(pages.courseDetails, 'txtName', null, data.Evt.Nm);
        //$('#' + pages.courseDetails + '-imgCourseType').attr('src', util.getIconUrlFromKey(data.Evt.Tp));
        util.setItem(pages.courseDetails, 'txtCourseCategorie', null, filterCategory);
        util.setItem(pages.courseDetails, 'txtTime', null, data.Rg);
        util.setItem(pages.courseDetails, 'txtRoom', null, data.Pl);
        util.setItem(pages.courseDetails, 'txtParticipants', null, data.Evt.Pt);
        util.setItem(pages.courseDetails, 'txtDescription', null, data.Evt.De, true);
        util.toggleButton(pages.courseDetails, 'cmdSendMessage', data.Io)
        util.toggleImage($('#' + pages.courseDetails + '-cmdThumbsUp'), data.Is);
        util.setItem(pages.courseDetails, 'lblAttend', null, data.Is ? strings.thumbsUp : strings.thumbsDown);
        phoneui.preprocessDOM();
    },

    inviteFriend: function () {
        var data = $(":root").data(KEYCOURSEDETAILS);
        phoneui.composeEmailFromPage($('#m1-CourseDetails'), '', strings.mailText1 + ' ' + data.Evt.Nm, strings.mailText2 + '\r\n' + strings.mailText6 + ' ' + data.Rg + ' ' + strings.mailText3 + ' ' + data.Evt.Nm + ' ' + strings.mailText4 + ' ' + lastProviderName + '.\r\n\r\n' + strings.mailText5);
    },

    getDayAndRender: function () {
        var day = new Date().getDay();
        courses.renderList(pages.courses + '-pnlResult', day);
    }
};

var languages = {

    translateSports: function () {
        this.load('TranslationSport.json', KEYLANGUAGESPORT, true, function () { languages.setSports(); })
    },

    translate: function () {
        this.load('Translation.json', KEYLANGUAGE, false, function () { languages.translateAll(); });
    },

    setSports: function () {
        $.each(languageSportsData, function (langindex, langitem) {
            if (langitem.Locale == userSettings.locale) {
                localStorage.setItem(KEYSPORTS, JSON.stringify(langitem));
                sportsLoaded = false;
                return;
            };
        });
    },

    setDestination: function (isSports, json) {
        if (isSports)
            languageSportsData = json;
        else
            languageData = json;
    },

    load: function (fileName, key, isSports, callback) {
        try {
            var destination = isSports ? languageSportsData : languageData;
            if (destination != null ? destination.length == undefined : true) {
                destination = util.load(key);
                languages.setDestination(isSports, destination);
                if (destination != null ? destination.length == undefined : true) {
                    $.getJSON(fileName, function (json) {
                        if (json !== undefined) {
                            util.save(key, json);
                            languages.setDestination(isSports, json);
                            if (callback)
                                callback();
                        };
                    }).fail(function (jqxhr, textStatus, error) {
                    });
                }
                else
                    callback();
            }
            else
                callback();
        }
        catch (err)
        {

        }
    },

    translateAll: function () {
        $.each(languageData, function (langindex, langitem) {
            if (langitem.Locale == userSettings.locale) {
                $.each(langitem.TranslationList, function (index, item) {
                    $.each(item.Translations, function (dataIndex, data) {
                        if (data.tp == 'Text') {
                            var element = $('#' + item.ScreenId + '-' + data.nm);
                            if (element)
                                element.html(data.vl);
                        } else if (data.tp == 'Placeholder') {
                            var element = $('#' + item.ScreenId + '-' + data.nm);
                            if (element)
                                element.attr('placeholder', data.vl);
                        } else if (data.tp == 'Js') {
                            strings[data.nm.trim()] = data.vl;
                        }
                    });
                });
                return;
            }
        });
    }
};

function mobiOneImpl() {


  
    this.gotoDistancePage = function (mode) {
        DistanceDetailMode = mode;
        util.gotoScreen(pages.selectDistance);
    };
    
    this.gotoSearchPage = function () {
        mobiOne.refreshDistance();
           if(DistanceDetailMode)
        {
            util.gotoScreen(pages.detailSearch);
        }
        else
        {
            util.gotoScreen(pages.sportscanner);
        }
    };
   
    this.gotoPage = function (page) {
        util.gotoPage(page);
    };

    this.gotoScreen = function (screen) {
        util.gotoScreen(screen);
    };

    this.home = function () {
        util.gotoPage(pages.sportscanner + '-Startup');
    };

    this.toggle = function (authenticated, gotoPage) {
        util.toggle(authenticated, gotoPage);
    };

    this.call = function (page, selector) {
        var phone = util.getElement(page, selector).text();
        phoneui.callPhone(phone);
    };

    this.openUrl = function (page, selector) {
        var url = util.getElement(page, selector).text();
        phoneui.showURL(url, '_blank');
    };

    this.sendMail = function (page, selector) {
        var email = util.getElement(page, selector).text();
        if (email !== '')
            phoneui.composeEmailFromPage($('#' + pages.sportscanner), email, '', '');
    };

    this.getUserLocation = function () {
        return userLocation.getUserLocation(function () {
            listObj.load(listObj.defaultDistance);
            return true;
        });
    };

    this.refreshSaveSearch = function() {
        userSettings.saveSearchSettings = $('#' + pages.settings + '-chkSaveSearchSettings input').is(':checked');
        util.saveSettings();
    };

    this.loadMap = function () {
        detailsObj.loadMap();
    };

    this.refreshDistance = function () {
        var selected = $('#' + pages.selectDistance + '-hidden-select-lstDistance option:selected');
        $('#' + pages.sportscanner + '-txtCurrentDistance').text(selected.text());
		$('#' + pages.detailSearch + '-txtCurrentDistance').text(selected.text());
		searchSettings.distance = selected.val();
		searchSettings.distanceText = selected.text();
        util.fillSearchMessage(pages.selectDistance);
    };

    this.toggleViewMyProviderEvents = function (vType) {
        listObj.toggleView(vType, true, pages.providereventList);
    };

    this.toggleView = function (vType) {
        listObj.toggleView(vType, true);
    };

    this.toggleDetailsView = function (vType) {
        detailsObj.toggleView(vType, true);
    };

    this.loadDetails = function () {
        detailsObj.loadDetails(event.srcElement);
    };

    this.loadProviderEvents = function () {
        listObj.getProviderEvents();
    };

    this.loadLatest = function () {
        providerEventMode = false;
        phoneui.showActivityDialog(strings.search);
        listObj.load(searchType.latest);
    };
    
    this.openDealUrl = function () {
        deals.openDealUrl();
    };

    this.loadDeals = function () {
        deals.loadList();
    };

    this.loadTopDeals = function () {
        deals.loadSingleList(0);
    };

    this.loadDailyDeals = function () {
        deals.loadSingleList(1);
    };

    this.loadDealDetails = function () {
        deals.loadDetails(event.srcElement);
    };

    this.refreshCourses = function () {
        courses.getCourses();
    };

    this.clearSports = function () {
        sports.clearSportSearch();
    };

    this.clearCustomText = function () {
        $('#' + pages.detailSearch + '-txtCustomText').val('');
        $('#' + pages.courseSearch + '-txtCustomText').val('');
        searchSettings.searchText = '';
    };

    this.clearLocation = function () {
        $('#' + pages.sportscanner + '-txtLocation').val('');
        $('#' + pages.detailSearch + '-txtLocation').val('');
        $('#' + pages.courseSearch + '-txtLocation').val('');
        searchSettings.placeName = '';
        searchSettings.longitude = '';
        searchSettings.latitude = '';
        util.saveSettings();
        sports.searchSports();
        phoneui.preprocessDOM();
    };

    this.loadMyData = function () {
        var key = userSettings.loginKey;
        if (key != '') {
            myData.loadList();
        }
        else
            userLogin.load();
    };

    this.loadMyEvents= function () {
        myData.loadSingleList(0);
    };

    this.loadMyProviders = function () {
        myData.loadSingleList(1);
    };

    this.loadExternal = function (pageName) {
        var url = 'http://blog.sportscanner.net/content/app/' + userSettings.locale + '/' + pageName;
        phoneui.showURL(url, '_blank');
        };

    this.startSearch = function () {
        listObj.setSelectedCategory(event.srcElement);
        onlyCourseProvider = false;
        $('#' + pages.detailSearch + '-txtCurrentCategorie').text(searchSettings.selectedCategoryName);
        if (useWizard) {
            listObj.startSearch();
            util.fillSearchMessage(pages.selectCategory);
        }
        else {
            util.gotoScreen(pages.detailSearch);
        }
    };

    this.showResults = function () {
        providerEventMode = false;
        onlyCourseProvider = false;
        searchSettings.searchText = $('#' + pages.detailSearch + '-txtCustomText').val();
        listObj.startSearch();
    };

    this.showCategories = function() {
        sports.showCategories(event.srcElement);
    };

    this.logout = function () {
        userLogin.logout();
    };

    this.login = function () {
        userLogin.login();
    };

    this.saveCourses = function () {
        courses.saveCourses();
    };

    this.loadMyCourses = function () {
         var key = userSettings.loginKey;
        if (key != '') 
        {
            courses.loadMyCourses();
        }
        else
            userLogin.load();
        
    };
    
    // Tom
    this.refreshMyCourses = function () {
        var key = userSettings.loginKey;
        if (key != '') 
        {
            courses.refreshMyCourses();
        }
        else
            userLogin.load();
        
    };

    this.showMyCourseSchedule = function () {
        courses.showMyCourseSchedule();
    };

    this.slideLeft = function () {
        pictures.slideLeft();
    };

    this.slideRight = function () {
        pictures.slideRight();
    };

    this.register = function () {
        userLogin.register();
    };

    this.showCourses = function(day) {
        courses.showCourses(day);
    };

    this.sendCourseMessage = function () {
        mailMessage.sendMessage(pages.courseMessages, searchType.sendCourseMessage);
    };

    this.sendMessage = function () {
        mailMessage.sendMessage(pages.messages, searchType.sendMessage);
    };

    this.share = function () {
        detailsObj.share();
    };

    this.openCourseMessageScreen = function () {
        mailMessage.openMessageScreen(pages.courseMessages, searchType.getCourseMessage);
    };

    this.openMessageScreen = function () {
        mailMessage.openMessageScreen(pages.messages, searchType.getMessage);
    };

    this.gotoWizardPage = function () {        
     if(useWizard)
        {
            util.gotoScreen(pages.sportscanner);
        }
        else
        {
            util.gotoScreen(pages.detailSearch);
        }
    };

    this.showCourseSchedule = function() {
        courses.getCourses();
    };

    this.openEventProvider = function () {
        detailsObj.openEventProvider();
    };

    this.loadCourseDetails = function () {
        courses.getDetails(event.srcElement);
    };

    this.inviteFriend = function () {
        courses.inviteFriend();
    };

    this.toggleLike = function () {
        var key = userSettings.loginKey;
        if (key != '')
            detailsObj.toggleLike();
        else
            userLogin.load();
    };


    this.loadMessageDetails = function (mailbox) {
        mailMessage.loadMessageDetails(event.srcElement, mailbox);
    };

    this.refreshMessages = function () {
        mailMessage.loadMailbox(false);
    };

    this.changeLanguage = function (locale) {
        userSettings.locale = locale;
        util.saveSettings();
        languages.translate();
        languages.translateSports();
    };


    this.courseSearch = function () {
        $('#' + pages.sportscanner + '-txtLocation').val($('#' + pages.courseSearch + '-txtLocation').val());
        $('#' + pages.detailSearch + '-txtCustomText').val($('#' + pages.courseSearch + '-txtCustomText').val());
        onlyCourseProvider = true;
        providerEventMode = false;
        searchSettings.searchText = $('#' + pages.detailSearch + '-txtCustomText').val();
        phoneui.showActivityDialog(strings.search);
        listObj.loadList();
    };
    
    this.editSearch = function () { 
        if (onlyCourseProvider)
            util.gotoScreen(pages.courseSearch)
        else
            util.gotoScreen(pages.detailSearch);
    };

    this.addOrRemoveUserEvent = function () {
        courses.addOrRemoveUserEvent();
    };


    this.loadMailbox = function () {
     var key = userSettings.loginKey;
        if (key != '') 
        {
            mailMessage.loadMailbox(true);
        }
        else
            userLogin.load();
        
    };

    
    this.backToSearch = function() {
        if (useWizard)
            util.gotoScreen(pages.selectCategory);
        else {
            util.gotoScreen(pages.detailSearch);
        };
    };
};

var detailsObj = new detailsImpl();
var mobiOne = new mobiOneImpl();

phoneui.prePageTransition = function (currentScreenId, targetScreenId) {

    var element = $('#' + pages.staticContent + '-htmlData');
    element.html('');
    phoneui.hideActivityDialog();
    if (targetScreenId == '#' + pages.selectSports) {
        sports.fillsportsList();
    } else if (targetScreenId == '#' + pages.settings) {
        var msg = strings.notLoggedIn;
        if (userSettings.loginKey != '')
            msg = strings.loggedIn + ' ' + userSettings.loginName;
        $('#' + pages.settings + '-lblPreLoginName').html(msg);
    } else if (targetScreenId == '#' + pages.pictures) {
        pictures.init();
    };
    if (targetScreenId == '#' + pages.sportscanner) {
        $('#' + pages.detailSearch + '-txtLocation').val($('#' + pages.sportscanner + '-txtLocation').val());
    }

    if (targetScreenId == '#' + pages.detailSearch) {
        $('#' + pages.sportscanner + '-txtLocation').val($('#' + pages.detailSearch + '-txtLocation').val());
    }
    if (currentScreenId == '#' + pages.detailSearch) {
        useWizard = false;
    }
    if (currentScreenId == '#' + pages.sportscanner) {
        searchSettings.searchText = '';
        useWizard = true;
    };
    if (currentScreenId == '#' + pages.eventList && targetScreenId == '#' + pages.details) {
        providerEventMode = false;
    };
}

/**
* Notification that the UI has transitioned to a new screen.
* 
* @param {String} newScreenId 
*/
phoneui.postPageTransition = function (newScreenId) {
    lastPage = newScreenId.replace('#', '');
    //languages.translateScreen(lastPage);
}

/**
* Notification that device orientation has changed. 
* 
* @param {String} newOrientation 
*/
phoneui.postOrientationChange = function (newOrientation) {
//$('#' + pages.sportscanner + '-pnlButtons').height(panelHt);

}

/**
* Called when document is loaded.
*/
phoneui.documentReadyHandler = function () {

    util.toggle(false);
    userLocation.setLocationAutoComplete(pages.sportscanner + '-txtLocation');
    userLocation.setLocationAutoComplete(pages.detailSearch + '-txtLocation');
    userLocation.setLocationAutoComplete(pages.courseSearch + '-txtLocation');
    util.loadSettings();

    keyHandler.init();
    
    languages.translate();
    languages.translateSports();
    courses.refreshMyCourses();
    document.addEventListener("backbutton", handleBackButton, false);
    analytics.create();
}
/**
 * Notification that the page's HTML/CSS/JS is about to be loaded.
 * Perform custom logic here, f.e. you can cancel request to the server.
 * @param {String} targetScreenId 
 * @returns {boolean} true to continue loading; false to halt loading
 */
phoneui.prePageLoad = function(targetScreenId) {
  // add custom pre-load code here
  // return false to terminate page loading, this cancels transition to page as well
}

